unit uCar;

interface

uses
	Windows, Classes, SysUtils, uMap, math,Contnrs;

type
	TCarException = class(Exception);
	
	TCommandItem = class
	public
		PosX,PosY,SpeedX,SpeedY,CommX,CommY:integer;
		constructor Create(px,py,sx,sy,cx,cy:integer);
	end;
	
	TCar = class
	private
		fMap:TMap;
		fPosX,fPosY:integer;
		fSpeedX,fSpeedY:integer;
		fLimiter:boolean;
		fComms:TObjectList;
	public
		constructor Create(xMap:TMap);
		destructor Destroy;override;
		procedure ResetCar;
		procedure IssueCommand(deltax,deltay:integer);
		
		property PosX:integer read fPosX;
		property PosY:integer read fPosY;
		property SpeedX:integer read fSpeedX;
		property SpeedY:integer read fSpeedY;
		property Limiter:boolean read fLimiter;
		property Commands:TObjectList read fComms;
	end;

implementation

{ TCar }

constructor TCar.Create(xMap: TMap);
begin
	fComms:=nil;
	fMap:=xMap;
	ResetCar;
end;

destructor TCar.Destroy;
begin
	freeAndNil(fComms);
	inherited;
end;

procedure TCar.IssueCommand(deltax, deltay: integer);
var
	nx,ny:integer;
begin
	fComms.Add(TCommandItem.Create(fPosX,fPosY,fSpeedX,fSpeedY,deltax,deltaY));
	Inc(fSpeedX,deltax);
	Inc(fSpeedY,deltay);
	if fLimiter then begin
		fSpeedX:=min(5,fSpeedX);
		fSpeedY:=min(5,fSpeedY);
	end;
	nx:=fPosX+fSpeedX;
	ny:=fPosY+fSpeedY;
	if (nx<0)or(nx>=fMap.Width)or(ny<0)or(ny>=fmap.Height) then begin
		fLimiter:=true;
		fSpeedX:=0;
		fSpeedY:=0;
	end else begin
		fPosX:=nx;
		fPosY:=ny;
	end;
end;

procedure TCar.ResetCar;
begin
	fPosX:=fMap.StartX;
	fPosY:=fMap.StartY;
	fSpeedX:=0;
	fSpeedY:=0;
	fLimiter:=false;
	freeAndNil(fComms);
	fComms:=TObjectList.Create(true);
end;

{ TCommandItem }

constructor TCommandItem.Create(px, py, sx, sy, cx, cy: integer);
begin
	PosX:=px;
	PosY:=py;
	SpeedX:=sx;
	SpeedY:=sy;
	CommX:=cx;
	CommY:=cy;
end;

end.
