unit uSlimeController;

interface

uses
	Windows, Classes, SysUtils, uCar, uMap, uPathSearcher, uAbstractController;

type
	TSlimeController = class(TController)
	private
		fSpeedSet:boolean;
		fLevel:integer;
		flix,fliy:integer;
	public
		procedure Start;override;
		function Step:boolean;override;
	end;

implementation

{ TSlimeController }

procedure TSlimeController.Start;
begin
	fSpeedSet:=false;
	fLevel:=1;
end;

function TSlimeController.Step: boolean;
var
	dx,dy:integer;

	function Sniff(px,py:integer):boolean;
	var
		posx,posy:integer;
	begin
		posx:=car.PosX+px;
		posy:=car.PosY+py;
		result:=false;
		if (posx<0)or(posx>=Map.Width)or(posy<0)or(posy>=map.Height) then
			exit;

		if Path.Route[posx,posy]=fLevel+1 then begin
			dx:=px;
			dy:=py;
			result:=true;
		end;
	end;
	
begin
	if fSpeedSet then begin
		fSpeedSet:=false;
		Car.IssueCommand(-flix,-fliy);
	end else begin
		fSpeedSet:=true;
		if Sniff(+1, 0) then
			Car.IssueCommand(dx,dy)
		else if Sniff(-1, 0) then
			Car.IssueCommand(dx,dy)
		else if Sniff( 0, 1) then
			Car.IssueCommand(dx,dy)
		else if Sniff( 0,-1) then
			Car.IssueCommand(dx,dy)
		else if Sniff(+1,+1) then
			Car.IssueCommand(dx,dy)
		else if Sniff(+1,-1) then
			Car.IssueCommand(dx,dy)
		else if Sniff(-1,+1) then
			Car.IssueCommand(dx,dy)
		else if Sniff(-1,-1) then
			Car.IssueCommand(dx,dy);
		inc(fLevel);
		flix:=dx;
		fliy:=dy;
	end;
	
	result:=(Car.PosX=Path.TargetX)and(Car.PosY=Path.TargetY);
end;

end.
